//+------------------------------------------------------------------+
//|                                                    e-DayOpenFib  |
//|                                                                  |
//| Last Update 22.02.07                                             |
//+------------------------------------------------------------------+
//| FinGeR aka Alexander Piechotta                                   |
//| Please make a donation                                           |
//| eGold  3644892                                                   |
//| WMZ    218811673742                                              |
//| Thanks                                                           |
//+------------------------------------------------------------------+


#property copyright "FinGeR aka Alexander Piechotta"
#property link      "5one51@googlemail.com"

#define MAGIC 00480012
extern int     HourOpenPos  = 23;
extern double  Lots = 0.1;
double  StopLoss = 10;
double  TakeProfit = 10;
extern double  TrailingStop=0;

string Name_Expert   = "e-DayOpenFib";
bool   UseSound      = False;       
string NameFileSound = "expert.wav"; 
bool   ShowComment   = True;        

int Slippage        = 3;      
int NumberOfTry     = 7;    
int PauseAfterError = 21;     

color clOpenBuy   = LightBlue;
color clOpenSell  = LightCoral;
color clCloseBuy  = Blue;
color clCloseSell = Red;
color clModifyBuy  = Aqua;
color clModifySell = Tomato;

int  Curr;  
datetime  PrevTime;
double today_open=0;
double rates_d1[2][6];
double rates_h1[2][6];
double l[4],h[4];

  
#include <stdlib.mqh>

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+

int init()
  {
InitParameters();
  
  }
  
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
Comment("");
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
  
if (Period()!=PERIOD_H1) {
      Comment("ERROR"+Name_Expert+" ONLY H1!");
      return;
    }  
  
if(Hour()==HourOpenPos)today_open = iOpen(NULL,NULL,0);

TrailingPositions();
InitParameters();

if(rates_h1[0][5]>1 ) return(0);      

if ( Hour() == HourOpenPos)
   {
   PrevTime=0;
   DeleteAllOrders();
   CloseAllPositions();
   InitParameters();
   OpenPositions();
   }

return(0);

}
//+------------------------------------------------------------------+

void OpenPosition(int op, double pp, double ldStop, double ldTake) {
  color  clOpen;
  int    err, it, ticket;
  string lsComm=GetCommentForOrder();

  if (op==OP_BUYSTOP) clOpen=clOpenBuy; else clOpen=clOpenSell;
 
  for (it=1; it<=NumberOfTry; it++) {
    while (!IsTradeAllowed()) Sleep(5000);
    RefreshRates();
    pp=NormalizeDouble(pp, Digits);
    ldStop=NormalizeDouble(ldStop, Digits);
    ldTake=NormalizeDouble(ldTake, Digits);
     ticket=OrderSend(Symbol(),op,Lots,pp,Slippage,ldStop,ldTake,lsComm,MAGIC,0,clOpen);
  if (ticket>0) {
    if (UseSound) PlaySound(NameFileSound); break;
    } else {
      err=GetLastError();
      Print("Error(",err,") opening position: ",ErrorDescription(err),", try ",it);
      Sleep(1000*PauseAfterError);
    }
  }
}




string GetNameTF(int TimeFrame) {
	switch (TimeFrame) {
		case PERIOD_MN1: return("Monthly");
		case PERIOD_W1:  return("Weekly");
		case PERIOD_D1:  return("Daily");
		case PERIOD_H4:  return("H4");
		case PERIOD_H1:  return("H1");
		case PERIOD_M30: return("M30");
		case PERIOD_M15: return("M15");
		case PERIOD_M5:  return("M5");
		case PERIOD_M1:  return("M1");
		default:		     return("UnknownPeriod");
	}
}



string GetCommentForOrder() {
  return(Name_Expert+" "+GetNameTF(Period()));
}


void OpenPositions() {
  double ldStop=0, ldTake=0, pp=0 ;
  int bs=GetTradeSignal();
  

   if (bs>0) {
     for (int i=1; i<4; i++) 
  { 
      pp=h[0];
      if (StopLoss!=0) ldStop=today_open;
      if (TakeProfit!=0) ldTake=h[i];
      //if(!ExistOrder(OP_BUYSTOP))
      OpenPosition(OP_BUYSTOP,pp, ldStop, ldTake);
  }
      for (i=1; i<4; i++) 
  {   
      pp=l[0];
      if (StopLoss!=0) ldStop=today_open;
      if (TakeProfit!=0) ldTake=l[i];
//      if(!ExistOrder(OP_SELLSTOP))
      OpenPosition(OP_SELLSTOP,pp, ldStop, ldTake);
      
    }
  
}

}

int GetTradeSignal() {
  int bs=0;
  bs=1;
 
return(bs);
}


void InitParameters() 
{
ArrayCopyRates(rates_h1, Symbol(), PERIOD_H1);
ArrayCopyRates(rates_d1, Symbol(), PERIOD_D1);
Fibo();
}



void DeleteAllOrders() {
  bool fd;
  for (int i=OrdersTotal()-1; i>=0; i--) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      if (OrderMagicNumber()==MAGIC ) {
        if (OrderSymbol()==Symbol()) {
          if (OrderType()==OP_BUYSTOP || OrderType()==OP_SELLSTOP) {
            fd=OrderDelete(OrderTicket());
            if (fd && UseSound) PlaySound(NameFileSound);
          }
        }
      }
    }
  }
}



void Fibo()
{

//for (int i=0;i<=25;i++)
//{
 //  if ((TimeHour(rates_h1[i][0])-Zeitverschiebung)==0)
   //{
     
      //today_open = rates_h1[i][1];      
     // break;
  // }
//}

l[0]= today_open - 34*Point;    
        
l[1]= today_open - 89*Point;
l[2]= today_open - 144*Point;
l[3]= today_open - 233*Point;
           
h[0]= today_open + 34*Point;  
         
h[1]= today_open + 89*Point;
h[2]= today_open + 144*Point;
h[3]= today_open + 233*Point;

}   
 

void TrailingPositions() {
 
 for (int i=0; i<OrdersTotal(); i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      if (OrderSymbol()==Symbol() && OrderMagicNumber()==MAGIC) {
        if (OrderType()==OP_BUY || OrderType()==OP_SELL ) TP();
        }
        }
        }


        for( i=0;i<OrdersTotal();i++)
   {
        OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
        
        if(OrderMagicNumber()!=MAGIC)
            continue;
       
        if(OrderType()<=OP_SELL &&OrderSymbol()==Symbol())
        {
            if(OrderType()==OP_BUY&&OrderSymbol()==Symbol())
            {
               if(TrailingStop>0)
               {
                    if(Bid-OrderOpenPrice()>(TrailingStop*Point))
                    {
                        if(OrderStopLoss()<(Bid-TrailingStop*Point))
                        {
                            OrderModify(OrderTicket(),OrderOpenPrice(),Bid-TrailingStop*Point,OrderTakeProfit(),0,Green);
                        }
                    }
               }
                
            }
            if(OrderType()==OP_SELL&&OrderSymbol()==Symbol())
            {
  
                if(TrailingStop>0)
                {
                    if(OrderOpenPrice()-Ask>(TrailingStop*Point))
                    {
                        if(OrderStopLoss()>(Ask+TrailingStop*Point)||(OrderStopLoss()==0))
                        {
                            OrderModify(OrderTicket(),OrderOpenPrice(),Ask+TrailingStop*Point,OrderTakeProfit(),0,Green);
                        }
                    }
                }
            }
        }
        
   }
   
   }

   
   
void CloseAllPositions() {
  bool   fc;
  double pp;
  int    err, it;

  for (int i=OrdersTotal()-1; i>=0; i--) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      if (OrderSymbol()==Symbol() && OrderMagicNumber()==MAGIC) {
        fc=False;
        for (it=1; it<=NumberOfTry; it++) {
          while (!IsTradeAllowed()) Sleep(5000);
          RefreshRates();
          if (OrderType()==OP_BUY) {
            pp=NormalizeDouble(Bid, Digits);
            fc=OrderClose(OrderTicket(), OrderLots(), pp, Slippage, clCloseBuy);
            if (fc) {
              if (UseSound) PlaySound(NameFileSound); break;
            } else {
              err=GetLastError();
              Print("Error(",err,") closing buy: ",ErrorDescription(err),", try ",it);
              Sleep(1000*PauseAfterError);
            }
          }
          if (OrderType()==OP_SELL) {
            pp=NormalizeDouble(Ask, Digits);
            fc=OrderClose(OrderTicket(), OrderLots(), pp, Slippage, clCloseSell);
            if (fc) {
              if (UseSound) PlaySound(NameFileSound); break;
            } else {
              err=GetLastError();
              Print("Error(",err,") closing sell: ",ErrorDescription(err),", try ",it);
              Sleep(1000*PauseAfterError);
            }
          }
        }
      }
    }
  }
}  


void TP() {
   
   if(PrevTime==1) return(0);
   PrevTime=1;
   
   int x=3,y=3;
   for (int i=0; i<OrdersTotal(); i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      if (OrderSymbol()==Symbol() && OrderMagicNumber()==MAGIC) {
        if (OrderType()==OP_BUYSTOP) {
        x--;
        ModifyStopLoss(l[0], h[x], clModifyBuy);
        }
        if (OrderType()==OP_SELLSTOP) {
        y--;
        ModifyStopLoss(h[0], l[y], clModifySell);
         
        }
      }
    }
  }
}


void ModifyStopLoss(double ldStop, double ldTake, color clModify) {
  bool   fm;
  double ldOpen=today_open;
  int    err;
 

  if (IsTradeAllowed()) {
    fm=OrderModify(OrderTicket(), ldOpen, ldStop, ldTake, 0, clModify);
    if (!fm) {
      err=GetLastError();
      Print("Error(",err,") modifying SL: ",err);
    }
  }
}

